"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const DEF_MODE = 'name';
const MODE_URL = {
    name: 'http://www.radio-browser.info/webservice/json/stations/byname/',
    tag: 'http://www.radio-browser.info/webservice/json/stations/bytag/',
    country: 'http://www.radio-browser.info/webservice/json/stations/bycountry/',
    language: 'http://www.radio-browser.info/webservice/json/stations/bylanguage/'
};
function search_radio(search, mode) {
    return new Promise((resolve, reject) => {
        const options = {
            method: 'GET',
            url: (MODE_URL[mode] || MODE_URL[DEF_MODE]) + search.split(' ').join('+')
        };
        require('request')(options, (err, _, body) => {
            if (err) {
                reject(err);
            }
            else {
                const json = JSON.parse(body);
                resolve(parse_radio(json));
            }
        });
    });
}
exports.search_radio = search_radio;
function parse_radio(json) {
    return Object.keys(json).map((key) => ({
        name: json[key].name,
        homepage: json[key].homepage,
        listeners: 'Null',
        description: 'Null',
        playing: 'Null',
        url: json[key].url,
        src: 'Radio',
        bitrate: json[key].bitrate,
        is_playlist: /\.m3u|\.pls/.test(json[key].url),
        entry: json[key]
    }));
}
